/*
 * swsvc.c - remote procedures; called by server stub.
 * Written by Ron Beam, 1996.
 */

#include <sys/ioctl.h>	/* for ioctl */
#include <fcntl.h>	/* for O_RDWR and O_NDELAY */
#include <rpc/rpc.h>	/* standard RPC include file */
#include "switch.h"	/* this file is generated by rpcgen */

#define DEV_NAME	"/dev/cua0"

static int fd = -1;
static long sw_mask = 0;

void open_port()
{
	fd = open(DEV_NAME, O_RDWR | O_NDELAY);

	if (fd < 0)
		fprintf(stderr,"swsvc: Error opening port!\n");
}

long *sw_set_1_svc(long *set_mask, struct svc_req *sr)
{
	static long sw;	/* must be static */
	unsigned int bits = 0;

	if (fd < 0)
		open_port();

	sw_mask = *set_mask & 0x03;	/* only care about lower 2 bits */

	if (sw_mask & 1)
		bits |= TIOCM_DTR;

	if (sw_mask & 2)
		bits |= TIOCM_RTS;

	ioctl(fd, TIOCMSET, &bits);

	sw = sw_mask;
	return(&sw);
}

long *sw_stat_1_svc(void *arg, struct svc_req *sr)
{
	static long sw;		/* must be static */

	sw = sw_mask;
	return(&sw);
}

